import numpy as np
import matplotlib.pyplot as plt
import scipy.linalg

rmax=0.5   #nm
N=1000
Delta=rmax/N

D=4.62     #eV
r0=0.126   #nm
alpha=2.38

cnst=2.073e-5 # hbar^2/(2*m_H * 1eV * 1nm^2)

r=np.linspace(0,rmax,N,endpoint=True)

V=-D+D*(alpha/r0)**2*(r-r0)**2

A=2*cnst/Delta**2 + V[1:N]
B=-cnst/Delta**2 * np.ones(N-2)

eigval,eigvec=scipy.linalg.eigh_tridiagonal(A,B)

plt.ylim([-5,0])
plt.plot(r,V,'k-')
for i in range(20):
    plt.plot(r[1:N],0.8*eigvec[:,i]+eigval[i],'b-')
plt.show()